为什么我不能在我的super()调用中使用try块?

ddolor 发布于 2018-03-06 exception 最后更新 2018-03-06 01:01 1143 浏览

因此,在Java中,构造函数的第一行必须是超级调用...不管它是隐式调用super(),还是显式调用另一个构造函数。我想知道的是,为什么我不能试试这个方法呢? 我的具体情况是我有一个模拟课堂进行测试。没有默认的构造函数,但我希望使测试更简单。我也想把从构造函数抛出的异常封装到RuntimeException中。 所以,我想要做的就是这样做:

public class MyClassMock extends MyClass {
    public MyClassMock() {
        try {
            super(0);
        } catch (Exception e) {
            throw new RuntimeException(e);
        }
    }
// Mocked methods
}
但是Java抱怨super并不是第一种说法。 我的解决方法:
public class MyClassMock extends MyClass {
    public static MyClassMock construct() {
        try {
            return new MyClassMock();
        } catch (Exception e) {
            throw new RuntimeException(e);
        }
    }
public MyClassMock() throws Exception {
        super(0);
    }
// Mocked methods
}
这是最好的解决方法吗?为什么Java不让我做前者?
我最好的猜测,“为什么”是Java不想让我有一个构造的对象在潜在不一致的状态......然而,在做一个模拟,我不关心这个。看来我应该能够做到以上......至少我知道上面是安全的,我的情况...或好像它应该是反正。 我重写从测试类中使用的任何方法,因此没有使用未初始化变量的风险。
已邀请:

oad

赞同来自:

不幸的是,编译器不能遵循理论原则,即使你可能知道它在你的情况下是安全的,但如果他们允许的话,它对于所有情况都是安全的。 换句话说,编译器并没有阻止你,它阻止了每个人,包括那些不知道它是不安全的并且需要特殊处理的人。这可能还有其他原因,因为如果有人知道如何处理这些问题,所有语言通常都有办法处理不安全的事情。 在C#.NET中有类似的规定,并且声明构造函数调用基础构造函数的唯一方法是:

public ClassName(...) : base(...)
这样做时,基础构造函数将在构造函数的主体之前被调用,并且不能更改此顺序。

faut

赞同来自:

我不知道Java是如何在内部实现的,但是如果超类的构造函数抛出一个异常,那么就没有你扩展的类的实例。例如,不可能调用toString()equals()方法,因为它们在大多数情况下都是被继承的。 Java可能允许在构造函数中围绕super()调用尝试/捕获,如果1.您覆盖超类中的所有方法,以及2.您不使用super.XXX()子句,但是这听起来太复杂了我。

aeius

赞同来自:

我不能假定对Java内部有深入的了解,但我的理解是,当编译器需要实例化派生类时,必须先创建基础(及其基础(...)之前)然后拍打在子类中创建的扩展。 所以甚至不存在不引人注目的变量或类似的东西的危险。当您尝试在基类“构造函数”之前的子类的构造函数中执行某些操作时,基本上要求编译器扩展一个还不存在的基对象实例。 编辑:在你的情况下, MyClass 成为基础对象, MyClassMock 是一个子类。

xesse

赞同来自:

这是为了防止某人从不受信任的代码创建新的SecurityManager对象。

public class Evil : SecurityManager {
  Evil()
  {
      try {
         super();
      } catch { Throwable t }
      {
      }
   }
}

xsed

赞同来自:

我知道这是一个古老的问题,但我喜欢它,因此,我决定给它一个我自己的答案。也许我理解为什么不能做到这一点将有助于讨论和未来的读者你有趣的问题。 让我从一个失败的对象构造的例子开始。 让我们定义一个类A,以便:

class A {
   private String a = "A";
public A() throws Exception {
        throw new Exception();
   }
}
现在,我们假设我们想在try...catch块中创建一个类型为A的对象。
A a = null;
try{
  a = new A();
}catch(Exception e) {
  //...
}
System.out.println(a);
显然,这段代码的输出是:null。 为什么Java不会返回A的部分构造版本?毕竟,在构造函数失败的时候,对象的name字段已经被初始化了,对吗? 那么,Java无法返回A的部分构造版本,因为该对象没有成功构建。该对象处于不一致状态,因此它被Java丢弃。你的变量A甚至没有被初始化,它保持为空。 如你所知,为了完全构建一个新的对象,它的所有超类必须首先被初始化。如果其中一个超类未能执行,那么该对象的最终状态是什么?这是不可能的。 看看这个更详细的例子
class A {
   private final int a;
   public A() throws Exception { 
      a = 10;
   }
}
class B extends A {
   private final int b;
   public B() throws Exception {
       methodThatThrowsException(); 
       b = 20;
   }
}
class C extends B {
   public C() throws Exception { super(); }
}
调用C的构造函数时,如果在初始化B时发生异常,那么最终的int变量b的值是什么? 因此,对象C不能创建,它是假的,它是垃圾,它没有完全初始化。 对我而言,这解释了为什么你的代码是非法的。

znon

赞同来自:

解决这个问题的一种方法是调用一个私有静态函数。 try-catch可以放在函数体中。

public class Test  {
  public Test()  {
     this(Test.getObjectThatMightThrowException());
  }
  public Test(Object o)  {
     //...
  }
  private static final Object getObjectThatMightThrowException()  {
     try  {
        return  new ObjectThatMightThrowAnException();
     }  catch(RuntimeException rtx)  {
        throw  new RuntimeException("It threw an exception!!!", rtx);
     }
  }
}

emagni

赞同来自:

我知道这个问题有很多答案,但我想就我为什么不被允许这样做提供一点小技巧,特别是回答为什么Java不允许你这样做。所以,你去... 现在,请记住super()必须在子类的构造函数中的任何其他位置之前被调用,因此,如果您确实在super()调用周围使用了trycatch块,则块将看起来像这样:

try {
   super();
   ...
} catch (Exception e) {
   super(); //This line will throw the same error...
   ...
}
如果super()fails in thetryblock, it HAS to be executed first in thecatchblock, so thatsuperruns before anything in your subclasss构造函数。这会给你带来与开始时相同的问题:如果抛出异常,它不会被捕获。 (在这种情况下,它只会在catch块中再次抛出。) 现在,Java也不允许上述代码。这段代码可能执行第一次超级调用的一半,然后再次调用它,这可能会导致一些超级类的问题。 现在,Java不允许抛出一个调用super()的异常而不是是因为异常可能在其他地方被捕获,并且程序会继续而不会在您的子类对象上调用super(),可能是因为该异常可能会将您的对象作为参数,并尝试更改尚未初始化的继承实例变量的值。